import React, { useState } from 'react';
import { Button } from 'antd';
import SelectBookLink from './selectBookLink';

interface SelectBookLinkButtonProps {
    children?: React.ReactNode;
    mpAccountId: number | null
    bookPlatForm: TASK_CREATE.BookPlatFormProps[]
    linkData: { [x: string]: any }[]
    onChange: (linkStr: string, miniprogramAppid?: string, miniprogramPage?: string) => void
}

const SelectBookLinkButton: React.FC<SelectBookLinkButtonProps> = ({ mpAccountId, bookPlatForm, linkData, onChange, children = '选择' }) => {

    /********************************/
    const [visible, setVisible] = useState<boolean>(false)
    /********************************/

    return <>
        <Button type="link" style={{ padding: 0 }} onClick={() => setVisible(true)}>
            {children}
        </Button>
        {visible && <SelectBookLink
            mpAccountId={mpAccountId}
            bookPlatForm={bookPlatForm}
            visible={visible}
            linkData={linkData}
            onClose={() => setVisible(false)}
            onChange={(linkStr, miniprogramAppid, miniprogramPage) => {
                console.log('linkStr', linkStr)
                onChange(linkStr, miniprogramAppid, miniprogramPage)
                setVisible(false)
            }}
        />}
    </>
};

export default SelectBookLinkButton;